unit Proxysetting;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, SHDocVw,Registry, ExtCtrls;

{
    -- 24/04/2012
    Proxysetting

   procedure GetSystemProxyData(var ProxyEnabled: boolean; var ProxyServer: string; var ProxyPort: integer);
       Proxy 
//   ------------------------------------------------- //
  Procedure NewProxyForWeb(WebControl:TWebBrowser;NewPorxyServerAndPort:string);
     Proxy    TWebBrowser
//   ------------------------------------------------- //
  function SetSystemProxy(host: string; port: string): boolean;
  //        host='' and port=''    


}

  procedure GetSystemProxyData(var ProxyEnabled: boolean; var ProxyServer: string; var ProxyPort: integer);
  Procedure NewProxyForWeb(WebControl:TWebBrowser;NewPorxyServerAndPort:string);
  function SetSystemProxy(host: string; port: string): boolean;

type
  TProxyForm = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ProxyForm: TProxyForm;

implementation

uses Wininet,urlmon;
{$R *.dfm}


{
by Naumov D.A.

http://www.foxbase.ru/delphi/kak-programmno-naznachit-proksi-server-dlya-brauzera.htm

--       Proxy   IE
--      
---    Delphi    


}


procedure GetSystemProxyData(var ProxyEnabled: boolean; var ProxyServer: string; var ProxyPort: integer);
var
  ProxyInfo: PInternetProxyInfo;
  Len: LongWord;
  i, j: integer;
begin
  Len := 4096;
  ProxyEnabled := false;
  GetMem(ProxyInfo, Len);
  try
    if InternetQueryOption(nil, INTERNET_OPTION_PROXY, ProxyInfo, Len)
    then
      if ProxyInfo^.dwAccessType = INTERNET_OPEN_TYPE_PROXY then
      begin
        ProxyEnabled:= True;
        ProxyServer := ProxyInfo^.lpszProxy;
      end
  finally
    FreeMem(ProxyInfo);
  end;
  if ProxyEnabled and (ProxyServer <> '') then
  begin
    i := Pos('http=', ProxyServer);
    if (i > 0) then
    begin
      Delete(ProxyServer, 1, i+5);
      j := Pos(';', ProxyServer);
      if (j > 0) then
        ProxyServer := Copy(ProxyServer, 1, j-1);
    end;
    i := Pos(':', ProxyServer);
    if (i > 0) then
    begin
      ProxyPort := StrToIntDef(Copy(ProxyServer, i+1, Length(ProxyServer)-i), 0);
      ProxyServer := Copy(ProxyServer, 1, i-1)
    end
  end;
end;

Procedure NewProxyForWeb(WebControl:TWebBrowser;NewPorxyServerAndPort:string);
var
  PIInfo: PInternetProxyInfo;
begin
  New(PIInfo);
  PIInfo^.dwAccessType := INTERNET_OPEN_TYPE_PROXY;
  PIInfo^.lpszProxy := PChar(NewPorxyServerAndPort);
  PIInfo^.lpszProxyBypass := PChar('');
  UrlMkSetSessionOption(INTERNET_OPTION_PROXY, piinfo,
    SizeOf(Internet_Proxy_Info), 0);
    Dispose(PIInfo);
end;

procedure TProxyForm.FormCreate(Sender: TObject);
var ProxyEnabled: boolean;
    ProxyServer: string;
    ProxyPort: integer;
begin
    GetSystemProxyData(ProxyEnabled,ProxyServer,ProxyPort);
    CheckBox1.Checked:=ProxyEnabled;
    edit1.text:=ProxyServer;
    edit2.text:=inttostr(ProxyPort);
end;

procedure TProxyForm.CheckBox1Click(Sender: TObject);
begin
      Edit1.Enabled:=CheckBox1.Checked;
      Edit2.Enabled:=CheckBox1.Checked;
      Label1.Enabled:=CheckBox1.Checked;
      Label2.Enabled:=CheckBox1.Checked;
end;

function SetSystemProxy(host: string; port: string): boolean;
  const

    INTERNET_PER_CONN_FLAGS = 1;
    PROXY_TYPE_PROXY = $00000002;
    INTERNET_PER_CONN_PROXY_BYPASS = 3;
    INTERNET_PER_CONN_PROXY_SERVER = 2;
    INTERNET_OPTION_PER_CONNECTION_OPTION = 75;
    PROXY_TYPE_DIRECT = $00000001;

  type

    INTERNET_PER_CONN_OPTION = record
      dwOption: DWORD;
      Value: record
        case Integer of
          1: (dwValue: DWORD);
          2: (pszValue: PChar); {Unicode/ANSI}
          3: (ftValue: TFileTime);
      end;
    end;

    LPINTERNET_PER_CONN_OPTION = ^INTERNET_PER_CONN_OPTION;
    INTERNET_PER_CONN_OPTION_List = record
      dwSize: DWORD;
      pszConnection: LPTSTR;
      dwOptionCount: DWORD;
      dwOptionError: DWORD;
      intOptions: LPINTERNET_PER_CONN_OPTION;
    end;
    LPINTERNET_PER_CONN_OPTION_List = ^INTERNET_PER_CONN_OPTION_List;

  var list: INTERNET_PER_CONN_OPTION_LIST;
      dwBufSize: DWORD;
      hInternet: Pointer;
      Options: array[1..3] of INTERNET_PER_CONN_OPTION;

begin
  Result := False;
  dwBufSize := SizeOf(list);
  list.dwSize := SizeOf(list);
  list.pszConnection := nil;
  list.dwOptionCount := High(Options);

  Options[1].dwOption := INTERNET_PER_CONN_FLAGS;

  Options[2].dwOption := INTERNET_PER_CONN_PROXY_SERVER;
  if (host='') or (port='') then
  begin
    Options[1].Value.dwValue := PROXY_TYPE_DIRECT;
    Options[2].Value.pszValue := PChar('');
  end else
  begin
    Options[1].Value.dwValue := PROXY_TYPE_PROXY;
    Options[2].Value.pszValue := PChar(host+':'+port);
  end;

  Options[3].dwOption := INTERNET_PER_CONN_PROXY_BYPASS;
  Options[3].Value.pszValue := PChar('');

  list.intOptions := @Options;
  hInternet := InternetOpen(PChar(''), INTERNET_OPEN_TYPE_DIRECT, nil, nil, 0);
  if hInternet <> nil then
  try
    Result := InternetSetOption(nil, INTERNET_OPTION_PER_CONNECTION_OPTION, @list, dwBufSize);
    Result := Result and InternetSetOption(nil, INTERNET_OPTION_REFRESH, nil, 0);
  finally
    InternetCloseHandle(hInternet)
  end;
end;

procedure TProxyForm.Button1Click(Sender: TObject);
var b:boolean;
begin
   if self.CheckBox1.Checked then
      b := SetSystemProxy(self.Edit1.Text,self.Edit2.text) //   
      else b := SetSystemProxy('',''); //  

   if b then begin
      Showmessage('    ');
     tag:=5;
     close;
   end;

end;

procedure TProxyForm.Button2Click(Sender: TObject);
begin
   tag:=-5;
  close;
end;

end.
